// prof. Constantin Galatan

#include <fstream>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

ifstream fin("interesant.in");
ofstream fout("interesant.out");

inline bool Substr(int& n, int& m, char* a, char* b);

int N, p, n, Lmax, Ns, len[201];
char s[5003], smax[5003], S[201][5003];
bool isSubs[201];

int main()
{
    fin >> p >> Ns;
    fin.get();

    if ( p == 1 )
    {
        while ( fin.getline(s, 10003))
        {
            n = strlen(s);
            if (n > Lmax || (n == Lmax && strcmp(s, smax) < 0))
            {
                Lmax = n;
                strcpy(smax, s);
            }
        }
        fout << smax << '\n';
        fout.close();
        exit(0);
    }
    bool ok;
    int k = 0;
    while (fin.getline(S[N], 10003))    // s - indicele sirului curent
    {
        ok = true;
        len[N] = strlen(S[N]);
		for (int j = 0; j < N; ++j)
		{
            if ( isSubs[j] ) continue;
            if ( len[N] <= len[j] )
                if ( Substr(len[N], len[j], S[N], S[j]) ) // S[i] inclus in S[j]
                {
                    ok = false;
                    break;
                }
            if ( Substr(len[j], len[N], S[j], S[N]) )
            {
				isSubs[j] = true;
				k++;
            }
		}
		if ( ok ) N++;
    }

	fout <<  N - k << '\n';
    for (int i = 0; i < N; ++i)
        if ( !isSubs[i] )
            fout << S[i] << '\n';

	fin.close();
	fout.close();

    return 0;
}

inline bool Substr(int& n, int& m, char* a, char* b) // caut a in b
{
    char *p = strchr(b, a[0]);
    if ( !p ) return false;
    for (int i = 1; i < n; ++i)
    {
        p = strchr(p + 1, a[i]);
        if ( !p ) return false;
        if ( m - (p - b) < n - i)
            return false;
    }
	return true;
}
