// prof. Constantin Galatan
#include <fstream>
#include <cstring>
#include <string>
#include <algorithm>
using namespace std;

ifstream fin("interesant.in");
ofstream fout("interesant.out");

inline bool Substr(string& a, string& b);

int n, k, len[201];
int N, p, Lmax, Ns;
string s, smax, S[201];
bool isSubs[201];

int main()
{
    fin >> p >> Ns;
    fin.get();

    if ( p == 1 )
    {
        while ( getline(fin, s))
        {
            n = s.size();
            if (n > Lmax || (n == Lmax && s < smax) )
            {
                Lmax = n;
                smax = s;
            }
        }
        fout << smax << '\n';
        fout.close();
        exit(0);
    }
    bool ok;
    while (getline(fin, S[N]))    // s - indicele sirului curent
    {
        ok = true;
        for (int j = 0; j < N; ++j)
		{
            if ( isSubs[j] ) continue;
            if ( S[N].size() <= S[j].size() )
                if ( Substr(S[N], S[j]) ) // S[i] inclus in S[j]
                {
                    ok = false;
                    break;
                }
            if ( Substr(S[j], S[N]) )
            {
                k++;
				isSubs[j] = true;
            }
		}
		if ( ok ) N++;
    }

	fout <<  N - k << '\n';
    for (int i = 0; i < N; ++i)
        if ( !isSubs[i] )
            fout << S[i] << '\n';

	fin.close();
	fout.close();

    return 0;
}

inline bool Substr(string& a, string& b) // caut a in b
{
	int p = -1;
	int n = a.size(), m = b.size();
	for (int i = 0; i < n; ++i)
	{
		p = b.find(a[i], p + 1);
		if ( p == string::npos )
			return false;
        if ( n - i > m - p )
            return false;
	}
	return true;
}
