// prof. Constantin Galatan
#include <fstream>
#include <cstring>
#include <algorithm>
#include <vector>
using namespace std;

ifstream fin("interesant.in");
ofstream fout("interesant.out");

inline bool Substr(int& n, int& m, char* a, char* b);
inline int Bs(const vector<int>& v, int pz);

int N, p, Lmax, Ns, n, k;
char s[5003], smax[5003], S[201][5003];
int len[201];
bool isSubs[201];
vector<int> P[200]['z' - '0' + 1];

int main()
{
    fin >> p >> Ns;

    fin.get();

    if ( p == 1 )
    {
        while ( fin.getline(s, 10003))
        {
            n = strlen(s);
            if (n > Lmax || (n == Lmax && strcmp(s, smax) < 0))
            {
                Lmax = n;
                strcpy(smax, s);
            }
        }
        fout << smax << '\n';
        fout.close();
        exit(0);
    }
    bool ok;


    while (fin.getline(S[N], 5003))
    {
        ok = true;
        len[N] = strlen(S[N]);
        for (int i = 'a'; i <= 'z'; ++i)
        {
            P[N][i - 'a'].clear();
            P[N][i - 'a'].shrink_to_fit();
        }
        for (char* c = S[N]; *c; ++c)
            P[N][*c - 'a'].push_back(c - S[N]);

        for (int j = 0; j < N; ++j)
		{
            if ( isSubs[j] ) continue;

            if ( len[N] <= len[j] )
            {
                if ( Substr(N, j, S[N], S[j]) ) // S[N] subsir in S[j]
                {
                    ok = false;
                    break;
                }
            }
            else
            {
                if ( Substr(j, N, S[j], S[N]) )
                {
                    isSubs[j] = true;
                    k++;
                }
            }
		}
		if ( ok ) N++;
    }

	fout <<  N - k << '\n';
    for (int i = 0; i < N; ++i)
        if ( !isSubs[i] )
            fout << S[i] << '\n';

	fin.close();
	fout.close();

    return 0;
}

inline int Bs(const vector<int>& v, int val)
{
	int st = 0, dr = v.size() - 1, m, next_pos = -1;

	while ( st <= dr )
	{
		m = (st + dr) / 2;
		if ( v[m] > val )
		{
			dr = m - 1;
			next_pos = v[m];
		}
		else
			st = m + 1;
	}
	return next_pos;
}

inline bool Substr(int& i, int& j, char* a, char* b) // caut a in b
{
    int n = len[i], m = len[j];
	int pz(-1);
	for (int i = 0; i < n; ++i)
	{
		pz = Bs(P[j][a[i] - 'a'], pz); // caut in P[litera] prima valoare mai mare decat pz

		if ( pz == -1 )  // n-am gasit
			return false;
         if ( m - pz < n - i)
            return false;
	}

	return true;
}
