// prof. Eugen Nodea
# include <fstream>
# include <iostream>
# include <cstring>
# define INF 9999
# define NR 105
# define N 11
# define mp make_pair
# define f first
# define s second
using namespace std;

ifstream f("miting.in");
ofstream g("miting.out");

short dx[] = {0, 1, 0,-1};
short dy[] = {1, 0,-1, 0};

int p, n, m, l, CiQ, CsQ, K;
short Costmin[N][N][NR*NR], nr[NR][NR], poz[NR], L[NR*NR], C[NR*NR], X[NR], Y[NR], Min, test[N][N];
char a[NR][NR], cuv[N];
pair <short, short> q[NR*NR*NR];

void bordare ()
{
    for (int i=0; i<=m+1; ++i)
        a[0][i] = a[n+1][i] = '#';
    for (int i=0; i<=n+1; ++i)
        a[i][0] = a[i][m+1] = '#';
}

void LEE (short i, short j)
{
    short k, lv, cv, l, c, urm, act;

    while (CiQ <= CsQ) {
        l = q[CiQ].f; c = q[CiQ].s; ++CiQ;
        act = nr[l][c];
        for (k=0; k<4; ++k) {
            lv = l + dx[k]; cv = c + dy[k];
            urm = nr[lv][cv];
            if (urm != 0 && Costmin[i][j][urm] > Costmin[i][j][act] + 1) {
                Costmin[i] [j][urm] = Costmin[i][j][act] + 1;
                q[++CsQ] = mp(lv, cv);
            }
        }
    }
}

int main ()
{
    short i, j, k, lmin, cmin, lmax = 0, cmax = 0, I, J;

    f >> p >> n >> m; f.get();
    bordare ();
    f.getline(cuv+1, N);
    l = strlen(cuv+1);
    for (i=1; i<=l; ++i) //pozitia unei litere in cuvant
        poz[cuv[i]] = i;
    for (i=1; i<=n; ++i) //citesc matricea
        f >> (a[i]+1);

    lmin = INF; cmin = INF;
    for (i=1; i<=n; ++i) {
        for (j=1; j<=m; ++j) {
            if (a[i][j] != '#') { //loc pe unde se poate merge
                ++K;
                nr[i][j] = K;
                L[K] = i; C[K] = j;
            }
            if (a[i][j] != '#' && a[i][j] !='_') { // e litera
                lmin = min(lmin, i);
                cmin = min(cmin, j);

                lmax = max(lmax, i);
                cmax = max(cmax, j);

                X[poz[a[i][j]]] = i; //pozitia literelor
                Y[poz[a[i][j]]] = j;
            }
        }
    }
    if (p == 1) {
        g << (lmax-lmin+1) * (cmax-cmin+1) << "\n";
        return 0;
    }
    for (i=1; i<=l; ++i) {
        for (j=1; j<=K; ++j)
                Costmin[i][i][j] = INF; //Costmin[i][j][K] - costul minim pentru a ajunge cu literele ditre i-j
                                        //                   pe a K-a pozitie libera din matrice

        Costmin[i][i][nr[X[i]][Y[i]]] = 0;

        CiQ = 1; CsQ = 1;
        q[CiQ] = mp(X[i], Y[i]);
        LEE (i, i);
    }

    for (k=2; k<=l; ++k) //lungimea 'echipei'
        for (i=1; i<=l-k+1; ++i) { //pozitia de start a 'echipei'
            j = i+k-1;
            CiQ = 1; CsQ = 0;
            test[i][j] = INF;

            for (I=1; I<=K; ++I) { //pozitia de pe harta care e libera
                Costmin[i][j][I] = INF;
                Min = Costmin[i][j][I];

                for (J=i; J<j; ++J)
                    Min = min(Min, (short)(Costmin[i][J][I] + Costmin[J+1][j][I]));

                Costmin[i][j][I] = Min;
                q[++CsQ] = mp(L[I], C[I]);
            }

            LEE (i, j);

            for (I=1; I<=K; ++I)
                test[i][j] = min(test[i][j], Costmin[i][j][I]);
        }
    Min = INF;
    for (i=1; i<=K; ++i)
        Min = min(Min, Costmin[1][l][i]);

    if (Min == INF) g << "-1\n";
               else g << Min << "\n";
    return 0;
}
