// prof. Mircea Lupse-Turpan - 100 puncte

#include <fstream>
using namespace std;

ifstream fin("cifre.in");
ofstream fout("cifre.out");

int Segments[] = {6,2,5,5,4,5,6,3,7,6};
int Up[] = {1,5,1,2,2,3,1,2,0,0};
int Total[] = {2,7,2,3,3,4,2,5,1,2};

int Solve1(unsigned long long N)
{
    int S = 0;
    while(N)
    {
        S += Segments[N%10];
        N /= 10;
    }
    return S;
}

unsigned long long Solve2(unsigned long long N)
{
    int X[25];
    unsigned long long Sol = 0;
    int k = 0;

    while(N)
    {
        X[++k] = N % 10;
        N /= 10;
    }

    for(int i = 1; i <= k; ++i)
    {
        unsigned long long P = Up[X[i]];
        for(int j = 1; j < i; ++j)
            P = P * Total[X[j]];
        Sol += P;
    }

    return Sol;
}

int main()
{
    unsigned long long V,N;

    fin>>V>>N;

    if(V==1)
        fout<<Solve1(N)<<"\n";

    if(V==2)
       fout<<Solve2(N)<<"\n";

    return 0;
}
