//Sandor Lukacs
#include <iostream>
#include <fstream>

using namespace std;

ifstream f("arma.in");
ofstream g("arma.out");

int opt,n,fa,p,v[10001],pw[10001],rez;
long long cant;

int cmmdc(int a, int b){
    int r;
    while(b != 0){
        r = a % b;
        a = b;
        b = r;
    }
    return a;
}

int ce_nr_la_puterea_p_da_v(int v, int p){
    int i,j,t;
    //iau valorile posibile si le ridic la puterea p
    if(p == 1) return v;
    for(i = 2; i*i <= v; i++){
        t = 1;
        for(j = 1; j <= p && t < v; j++){
            t = t * i;
        }
        if(t == v) return i;
    }
}

int main()
{
    int i,d;
    f>>opt>>n;
    for(i = 1; i <= n; ++i) f>>v[i];//citesc distantele

    for(i = 1; i <= n; ++i){
        //descompun fiecare distanta in factori primi
        fa = 2;
        rez = 0;
        d = v[i];
        while(fa * fa <= d){
            p = 0;//puterea la acre apare fa in descompunerea lui v[i]
            while(d % fa ==0){
                d = d / fa;
                p = p + 1;
            }
            if(p != 0){//daca fa apare in descompunerea in factori primi
                rez = cmmdc(rez,p);//calculez cmmdc al puterilor
            }
            fa = fa + 1;//trec la urmatorul factor prim posibil
        }
        if(d == 1) pw[i] = rez;
        else pw[i] = 1;

    }
    if(opt == 1){
        for(i = 1; i <= n; ++i)
            cant = cant + ce_nr_la_puterea_p_da_v(v[i], pw[i]);
        g<<cant;
    }
    else {
        for(i = 1; i <= n; ++i) g<<pw[i]<<"\n";
    }
    return 0;
}
