//Em. Cerchez 85 puncte
#include <fstream>
#define VMAX 50000
#define NMAX 10000
#define NRMAXPRIME 50000

using namespace std;
ifstream fin("arma.in");
ofstream fout("arma.out");

int n, nrprim, nrf, cerinta;
bool ciur[VMAX];
int prim[NRMAXPRIME];
int fp[NRMAXPRIME];
int mf[NRMAXPRIME];
int p[NMAX];
int cant;

void eratostene();
void afisare();
void determina(int d, int &p, int &c);
int cmmdc();
int euclid(int a, int b);
int putere(int x, int y);

int main()
{int i, d, c;
 eratostene();
 fin>>cerinta>>n;
 for (i=0; i<n; i++)
      {
       fin>>d;
       determina(d,p[i],c);
       cant+=c;
      }
 afisare();
 return 0;
}

void eratostene()
{int d, j;
 for (d=2; d*d<VMAX; d++)
      if (!ciur[d])
          for (j=d*d; j<VMAX; j+=d)
              ciur[j]=1;
 //transfer intr-un vector numerele prime <=vmax
 prim[0]=2; nrprim=1;
 for (d=3; d<VMAX; d+=2)
      if (!ciur[d]) prim[nrprim++]=d;
}

void determina(int d, int &p, int &c)
{int m, j;
 nrf=0;
 for (j=0; j<nrprim && prim[j]*prim[j]<=d; j++)
     {
      for (m=0; d%prim[j]==0; m++,d/=prim[j]);
	  if (m)
         {
          fp[nrf]=prim[j];
          mf[nrf++]=m;
          }
      }
 if (d>1)
    {
     fp[nrf]=d;
     mf[nrf++]=1;
    }
 p=cmmdc();
 c=1;
 for (j=0; j<nrf; j++)
      c*=putere(fp[j],mf[j]/p);
}

void afisare()
{int i;
if (cerinta==1)
 fout<<cant<<'\n';
else
 for (i=0; i<n; i++) fout<<p[i]<<'\n';
 fout.close();
}

int cmmdc()
{int d=mf[0], i;
 for (i=1; i<nrf; i++)
      d=euclid(d,mf[i]);
 return d;
}

int euclid(int a, int b)
{int r;
 while (b)
   {
       r=a%b; a=b; b=r;
   }
 return a;
}

int putere(int x, int y)
{int p;
 if (y==0) return 1;
 p=putere(x,y/2);
 if (y%2) return x*p*p;
 return p*p;
}
