// prof. Mircea Lupse-Turpan - 100 puncte
#include <fstream>
#include <cstring>
using namespace std;
ifstream fin("pic.in");
ofstream fout("pic.out");

const int NMax = 55;
const long long oo = 1LL << 62;
int V, N, Sum;
int C[NMax][NMax];
long long F[NMax][NMax];

void Read()
{
    fin >> V >> N;
    for(int i = 1; i <= N; ++i)
        for(int j = 1; j <= i; ++j)
        {
            fin >> C[i][j];
            Sum += C[i][j];
        }
}

int Solve1()
{
    int Max = 0,Level = 1;
    for(int i = 1; i <= N; ++i)
    {
        int S = 0;
        for(int j = 1; j <= i; ++j)
            S += C[i][j];
        if(S > Max)
        {
            Max = S;
            Level = i;
        }
    }
    return Level;
}

bool Check(long long Val)
{
    memset(F,0,sizeof(F));
    F[1][1] = Val;

    for(int i = 1; i <= N; ++i)
        for(int j = 1; j <= i; ++j)
        {
            F[i+1][j]   += (F[i][j] - C[i][j] + 1) / 2;
            F[i+1][j+1] += (F[i][j] - C[i][j]) / 2;
        }
    for(int i = 1; i <= N; ++i)
        if (F[N][i] < C[N][i])
            return 0;
    return 1;
}

long long Solve2()
{
    long long Sol = -1;
    long long Left = Sum, Right = oo;
    while(Left <= Right)
    {
        long long Mid = (Left + Right) / 2;
        if(Check(Mid))
        {
            Sol = Mid;
            Right = Mid - 1;
        }
        else
            Left = Mid + 1;
    }
    return Sol;
}

int main()
{
    Read();

    if(V == 1)
        fout<<Solve1()<<"\n";

    if(V == 2)
    {
        long long T = Solve2();
        fout<<T<<" "<<T - Sum<<"\n";
    }
    return 0;
}
